<?php
/*
 * Generated by PEG.js 0.8.0. with php-pegjs plugin
 *
 * http://pegjs.majda.cz/
 */


/* Usefull functions: */

/* Gutenberg_PEG_chr_unicode - get unicode character from its char code */
if (!function_exists('Gutenberg_PEG_chr_unicode')) { function Gutenberg_PEG_chr_unicode($code) { return mb_convert_encoding('&#' . $code . ';', 'UTF-8', 'HTML-ENTITIES');} }
/* Gutenberg_PEG_peg_regex_test - multibyte regex test */
if (!function_exists('Gutenberg_PEG_peg_regex_test')) { function Gutenberg_PEG_peg_regex_test($pattern, $string) { if (substr($pattern, -1) == 'i') return mb_eregi(substr($pattern, 1, -2), $string); else return mb_ereg(substr($pattern, 1, -1), $string);}}

/* Syntax error exception */
if (!class_exists("Gutenberg_PEG_SyntaxError", false)){
class Gutenberg_PEG_SyntaxError extends Exception
{
    public $expected;
    public $found;
    public $grammarOffset;
    public $grammarLine;
    public $grammarColumn;
    public $name;
    public function __construct($message, $expected, $found, $offset, $line, $column)
    {
        parent::__construct($message, 0);
        $this->expected = $expected;
        $this->found = $found;
        $this->grammarOffset = $offset;
        $this->grammarLine = $line;
        $this->grammarColumn = $column;
        $this->name = "Gutenberg_PEG_SyntaxError";
    }
};}

class Gutenberg_PEG_Parser {


    private $peg_currPos          = 0;
    private $peg_reportedPos      = 0;
    private $peg_cachedPos        = 0;
    private $peg_cachedPosDetails = array('line' => 1, 'column' => 1, 'seenCR' => false );
    private $peg_maxFailPos       = 0;
    private $peg_maxFailExpected  = array();
    private $peg_silentFails      = 0;
    private $input                = "";


    private function cleanup_state(){
      $this->peg_currPos          = 0;
      $this->peg_reportedPos      = 0;
      $this->peg_cachedPos        = 0;
      $this->peg_cachedPosDetails = array('line' => 1, 'column' => 1, 'seenCR' => false );
      $this->peg_maxFailPos       = 0;
      $this->peg_maxFailExpected  = array();
      $this->peg_silentFails      = 0;
      $this->input                = "";

    }


    private function text() {
      return substr($this->input, $this->peg_reportedPos, $this->peg_reportedPos + $this->peg_currPos);
    }

    private function offset() {
      return $this->peg_reportedPos;
    }

    private function line() {
      $compute_pd = $this->peg_computePosDetails($this->peg_reportedPos);
      return $compute_pd["line"];
    }

    private function column() {
      $compute_pd = $this->peg_computePosDetails($this->peg_reportedPos);
      return $compute_pd["column"];
    }

    private function expected($description) {
      throw $this->peg_buildException(
        null,
        array(array("type" => "other", "description" => $description )),
        $this->peg_reportedPos
      );
    }

    private function error($message) {
      throw $this->peg_buildException($message, null, $this->peg_reportedPos);
    }

    private function peg_advancePos(&$details, $startPos, $endPos) {
      for ($p = $startPos; $p < $endPos; $p++) {
        $ch = mb_substr($this->input, $p, 1, "UTF-8");
        if ($ch === "\n") {
          if (!$details["seenCR"]) { $details["line"]++; }
          $details["column"] = 1;
          $details["seenCR"] = false;
        } else if ($ch === "\r" || $ch === "\u2028" || $ch === "\u2029") {
          $details["line"]++;
          $details["column"] = 1;
          $details["seenCR"] = true;
        } else {
          $details["column"]++;
          $details["seenCR"] = false;
        }
      }
    }

    private function peg_computePosDetails($pos) {
      if ($this->peg_cachedPos !== $pos) {
        if ($this->peg_cachedPos > $pos) {
          $this->peg_cachedPos = 0;
          $this->peg_cachedPosDetails = array( "line" => 1, "column" => 1, "seenCR" => false );
        }
        $this->peg_advancePos($this->peg_cachedPosDetails, $this->peg_cachedPos, $pos);
        $this->peg_cachedPos = $pos;
      }

      return $this->peg_cachedPosDetails;
    }

    private function peg_fail($expected) {
      if ($this->peg_currPos < $this->peg_maxFailPos) { return; }

      if ($this->peg_currPos > $this->peg_maxFailPos) {
        $this->peg_maxFailPos = $this->peg_currPos;
        $this->peg_maxFailExpected = array();
      }

      $this->peg_maxFailExpected[] = $expected;
    }

    private function peg_buildException_expectedComparator($a, $b) {
      if ($a["description"] < $b["description"]) {
        return -1;
      } else if ($a["description"] > $b["description"]) {
        return 1;
      } else {
        return 0;
      }
    }

    private function peg_buildException($message, $expected, $pos) {
      $posDetails = $this->peg_computePosDetails($pos);
      $found      = $pos < mb_strlen($this->input, "UTF-8") ? mb_substr($this->input, $pos, 1, "UTF-8") : null;

      if ($expected !== null) {
        usort($expected, array($this, "peg_buildException_expectedComparator"));
        $i = 1;
        while ($i < count($expected)) {
          if ($expected[$i - 1] === $expected[$i]) {
            array_splice($expected, $i, 1);
          } else {
            $i++;
          }
        }
      }

      if ($message === null) {
        $expectedDescs = array_fill(0, count($expected), null);

        for ($i = 0; $i < count($expected); $i++) {
          $expectedDescs[$i] = $expected[$i]["description"];
        }

        $expectedDesc = count($expected) > 1
          ? join(", ", array_slice($expectedDescs, 0, -1))
              . " or "
              . $expectedDescs[count($expected) - 1]
          : $expectedDescs[0];

        $foundDesc = $found ? json_encode($found) : "end of input";

        $message = "Expected " . $expectedDesc . " but " . $foundDesc . " found.";
      }

      return new Gutenberg_PEG_SyntaxError(
        $message,
        $expected,
        $found,
        $pos,
        $posDetails["line"],
        $posDetails["column"]
      );
    }

    private $peg_FAILED;
    private $peg_c0;
    private $peg_c1;
    private $peg_c2;
    private $peg_c3;
    private $peg_c4;
    private $peg_c5;
    private $peg_c6;
    private $peg_c7;
    private $peg_c8;
    private $peg_c9;
    private $peg_c10;
    private $peg_c11;
    private $peg_c12;
    private $peg_c13;
    private $peg_c14;
    private $peg_c15;
    private $peg_c16;
    private $peg_c17;
    private $peg_c18;
    private $peg_c19;
    private $peg_c20;
    private $peg_c21;
    private $peg_c22;
    private $peg_c23;
    private $peg_c24;
    private $peg_c25;
    private $peg_c26;
    private $peg_c27;
    private $peg_c28;
    private $peg_c29;

    private function peg_f0($blockName, $a) { return $a; }
    private function peg_f1($blockName, $attrs) {
        return array(
          'blockName'  => $blockName,
          'attrs'      => $attrs,
          'rawContent' => '',
        );
        }
    private function peg_f2($s, $c) { return $c; }
    private function peg_f3($s, $ts, $e) { return $s['blockName'] === $e['blockName']; }
    private function peg_f4($s, $ts, $e) {
        return array(
          'blockName'  => $s['blockName'],
          'attrs'      => $s['attrs'],
          'rawContent' => implode( '', $ts ),
        );
        }
    private function peg_f5($c) { return $c; }
    private function peg_f6($ts) {
        return array(
          'attrs'      => array(),
          'rawContent' => implode( '', $ts ),
        );
        }
    private function peg_f7($blockName, $attrs) {
        return array(
          'blockName' => $blockName,
          'attrs'     => $attrs,
        );
        }
    private function peg_f8($blockName) {
        return array(
          'blockName' => $blockName,
        );
        }
    private function peg_f9($attrs) { return json_decode( $attrs, true ); }

    private function peg_parseDocument() {

      $s0 = $this->peg_parseWP_Block_List();

      return $s0;
    }

    private function peg_parseWP_Block_List() {

      $s0 = array();
      $s1 = $this->peg_parseWP_Block();
      while ($s1 !== $this->peg_FAILED) {
        $s0[] = $s1;
        $s1 = $this->peg_parseWP_Block();
      }

      return $s0;
    }

    private function peg_parseWP_Block() {

      $s0 = $this->peg_parseWP_Block_Void();
      if ($s0 === $this->peg_FAILED) {
        $s0 = $this->peg_parseWP_Block_Balanced();
        if ($s0 === $this->peg_FAILED) {
          $s0 = $this->peg_parseWP_Block_Html();
        }
      }

      return $s0;
    }

    private function peg_parseWP_Block_Void() {

      $s0 = $this->peg_currPos;
      if (mb_substr($this->input, $this->peg_currPos, 4, "UTF-8") === $this->peg_c0) {
        $s1 = $this->peg_c0;
        $this->peg_currPos += 4;
      } else {
        $s1 = $this->peg_FAILED;
        if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c1); }
      }
      if ($s1 !== $this->peg_FAILED) {
        $s2 = array();
        $s3 = $this->peg_parseWS();
        if ($s3 !== $this->peg_FAILED) {
          while ($s3 !== $this->peg_FAILED) {
            $s2[] = $s3;
            $s3 = $this->peg_parseWS();
          }
        } else {
          $s2 = $this->peg_FAILED;
        }
        if ($s2 !== $this->peg_FAILED) {
          if (mb_substr($this->input, $this->peg_currPos, 3, "UTF-8") === $this->peg_c2) {
            $s3 = $this->peg_c2;
            $this->peg_currPos += 3;
          } else {
            $s3 = $this->peg_FAILED;
            if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c3); }
          }
          if ($s3 !== $this->peg_FAILED) {
            $s4 = $this->peg_parseWP_Block_Name();
            if ($s4 !== $this->peg_FAILED) {
              $s5 = array();
              $s6 = $this->peg_parseWS();
              if ($s6 !== $this->peg_FAILED) {
                while ($s6 !== $this->peg_FAILED) {
                  $s5[] = $s6;
                  $s6 = $this->peg_parseWS();
                }
              } else {
                $s5 = $this->peg_FAILED;
              }
              if ($s5 !== $this->peg_FAILED) {
                $s6 = $this->peg_currPos;
                $s7 = $this->peg_parseWP_Block_Attributes();
                if ($s7 !== $this->peg_FAILED) {
                  $s8 = array();
                  $s9 = $this->peg_parseWS();
                  if ($s9 !== $this->peg_FAILED) {
                    while ($s9 !== $this->peg_FAILED) {
                      $s8[] = $s9;
                      $s9 = $this->peg_parseWS();
                    }
                  } else {
                    $s8 = $this->peg_FAILED;
                  }
                  if ($s8 !== $this->peg_FAILED) {
                    $this->peg_reportedPos = $s6;
                    $s7 = $this->peg_f0($s4, $s7);
                    $s6 = $s7;
                  } else {
                    $this->peg_currPos = $s6;
                    $s6 = $this->peg_FAILED;
                  }
                } else {
                  $this->peg_currPos = $s6;
                  $s6 = $this->peg_FAILED;
                }
                if ($s6 === $this->peg_FAILED) {
                  $s6 = null;
                }
                if ($s6 !== $this->peg_FAILED) {
                  if (mb_substr($this->input, $this->peg_currPos, 4, "UTF-8") === $this->peg_c4) {
                    $s7 = $this->peg_c4;
                    $this->peg_currPos += 4;
                  } else {
                    $s7 = $this->peg_FAILED;
                    if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c5); }
                  }
                  if ($s7 !== $this->peg_FAILED) {
                    $this->peg_reportedPos = $s0;
                    $s1 = $this->peg_f1($s4, $s6);
                    $s0 = $s1;
                  } else {
                    $this->peg_currPos = $s0;
                    $s0 = $this->peg_FAILED;
                  }
                } else {
                  $this->peg_currPos = $s0;
                  $s0 = $this->peg_FAILED;
                }
              } else {
                $this->peg_currPos = $s0;
                $s0 = $this->peg_FAILED;
              }
            } else {
              $this->peg_currPos = $s0;
              $s0 = $this->peg_FAILED;
            }
          } else {
            $this->peg_currPos = $s0;
            $s0 = $this->peg_FAILED;
          }
        } else {
          $this->peg_currPos = $s0;
          $s0 = $this->peg_FAILED;
        }
      } else {
        $this->peg_currPos = $s0;
        $s0 = $this->peg_FAILED;
      }

      return $s0;
    }

    private function peg_parseWP_Block_Balanced() {

      $s0 = $this->peg_currPos;
      $s1 = $this->peg_parseWP_Block_Start();
      if ($s1 !== $this->peg_FAILED) {
        $s2 = array();
        $s3 = $this->peg_currPos;
        $s4 = $this->peg_currPos;
        $this->peg_silentFails++;
        $s5 = $this->peg_parseWP_Block_End();
        $this->peg_silentFails--;
        if ($s5 === $this->peg_FAILED) {
          $s4 = null;
        } else {
          $this->peg_currPos = $s4;
          $s4 = $this->peg_FAILED;
        }
        if ($s4 !== $this->peg_FAILED) {
          $s5 = $this->peg_parseAny();
          if ($s5 !== $this->peg_FAILED) {
            $this->peg_reportedPos = $s3;
            $s4 = $this->peg_f2($s1, $s5);
            $s3 = $s4;
          } else {
            $this->peg_currPos = $s3;
            $s3 = $this->peg_FAILED;
          }
        } else {
          $this->peg_currPos = $s3;
          $s3 = $this->peg_FAILED;
        }
        while ($s3 !== $this->peg_FAILED) {
          $s2[] = $s3;
          $s3 = $this->peg_currPos;
          $s4 = $this->peg_currPos;
          $this->peg_silentFails++;
          $s5 = $this->peg_parseWP_Block_End();
          $this->peg_silentFails--;
          if ($s5 === $this->peg_FAILED) {
            $s4 = null;
          } else {
            $this->peg_currPos = $s4;
            $s4 = $this->peg_FAILED;
          }
          if ($s4 !== $this->peg_FAILED) {
            $s5 = $this->peg_parseAny();
            if ($s5 !== $this->peg_FAILED) {
              $this->peg_reportedPos = $s3;
              $s4 = $this->peg_f2($s1, $s5);
              $s3 = $s4;
            } else {
              $this->peg_currPos = $s3;
              $s3 = $this->peg_FAILED;
            }
          } else {
            $this->peg_currPos = $s3;
            $s3 = $this->peg_FAILED;
          }
        }
        if ($s2 !== $this->peg_FAILED) {
          $s3 = $this->peg_parseWP_Block_End();
          if ($s3 !== $this->peg_FAILED) {
            $this->peg_reportedPos = $this->peg_currPos;
            $s4 = $this->peg_f3($s1, $s2, $s3);
            if ($s4) {
              $s4 = null;
            } else {
              $s4 = $this->peg_FAILED;
            }
            if ($s4 !== $this->peg_FAILED) {
              $this->peg_reportedPos = $s0;
              $s1 = $this->peg_f4($s1, $s2, $s3);
              $s0 = $s1;
            } else {
              $this->peg_currPos = $s0;
              $s0 = $this->peg_FAILED;
            }
          } else {
            $this->peg_currPos = $s0;
            $s0 = $this->peg_FAILED;
          }
        } else {
          $this->peg_currPos = $s0;
          $s0 = $this->peg_FAILED;
        }
      } else {
        $this->peg_currPos = $s0;
        $s0 = $this->peg_FAILED;
      }

      return $s0;
    }

    private function peg_parseWP_Block_Html() {

      $s0 = $this->peg_currPos;
      $s1 = array();
      $s2 = $this->peg_currPos;
      $s3 = $this->peg_currPos;
      $this->peg_silentFails++;
      $s4 = $this->peg_parseWP_Block_Balanced();
      $this->peg_silentFails--;
      if ($s4 === $this->peg_FAILED) {
        $s3 = null;
      } else {
        $this->peg_currPos = $s3;
        $s3 = $this->peg_FAILED;
      }
      if ($s3 !== $this->peg_FAILED) {
        $s4 = $this->peg_currPos;
        $this->peg_silentFails++;
        $s5 = $this->peg_parseWP_Block_Void();
        $this->peg_silentFails--;
        if ($s5 === $this->peg_FAILED) {
          $s4 = null;
        } else {
          $this->peg_currPos = $s4;
          $s4 = $this->peg_FAILED;
        }
        if ($s4 !== $this->peg_FAILED) {
          $s5 = $this->peg_parseAny();
          if ($s5 !== $this->peg_FAILED) {
            $this->peg_reportedPos = $s2;
            $s3 = $this->peg_f5($s5);
            $s2 = $s3;
          } else {
            $this->peg_currPos = $s2;
            $s2 = $this->peg_FAILED;
          }
        } else {
          $this->peg_currPos = $s2;
          $s2 = $this->peg_FAILED;
        }
      } else {
        $this->peg_currPos = $s2;
        $s2 = $this->peg_FAILED;
      }
      if ($s2 !== $this->peg_FAILED) {
        while ($s2 !== $this->peg_FAILED) {
          $s1[] = $s2;
          $s2 = $this->peg_currPos;
          $s3 = $this->peg_currPos;
          $this->peg_silentFails++;
          $s4 = $this->peg_parseWP_Block_Balanced();
          $this->peg_silentFails--;
          if ($s4 === $this->peg_FAILED) {
            $s3 = null;
          } else {
            $this->peg_currPos = $s3;
            $s3 = $this->peg_FAILED;
          }
          if ($s3 !== $this->peg_FAILED) {
            $s4 = $this->peg_currPos;
            $this->peg_silentFails++;
            $s5 = $this->peg_parseWP_Block_Void();
            $this->peg_silentFails--;
            if ($s5 === $this->peg_FAILED) {
              $s4 = null;
            } else {
              $this->peg_currPos = $s4;
              $s4 = $this->peg_FAILED;
            }
            if ($s4 !== $this->peg_FAILED) {
              $s5 = $this->peg_parseAny();
              if ($s5 !== $this->peg_FAILED) {
                $this->peg_reportedPos = $s2;
                $s3 = $this->peg_f5($s5);
                $s2 = $s3;
              } else {
                $this->peg_currPos = $s2;
                $s2 = $this->peg_FAILED;
              }
            } else {
              $this->peg_currPos = $s2;
              $s2 = $this->peg_FAILED;
            }
          } else {
            $this->peg_currPos = $s2;
            $s2 = $this->peg_FAILED;
          }
        }
      } else {
        $s1 = $this->peg_FAILED;
      }
      if ($s1 !== $this->peg_FAILED) {
        $this->peg_reportedPos = $s0;
        $s1 = $this->peg_f6($s1);
      }
      $s0 = $s1;

      return $s0;
    }

    private function peg_parseWP_Block_Start() {

      $s0 = $this->peg_currPos;
      if (mb_substr($this->input, $this->peg_currPos, 4, "UTF-8") === $this->peg_c0) {
        $s1 = $this->peg_c0;
        $this->peg_currPos += 4;
      } else {
        $s1 = $this->peg_FAILED;
        if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c1); }
      }
      if ($s1 !== $this->peg_FAILED) {
        $s2 = array();
        $s3 = $this->peg_parseWS();
        if ($s3 !== $this->peg_FAILED) {
          while ($s3 !== $this->peg_FAILED) {
            $s2[] = $s3;
            $s3 = $this->peg_parseWS();
          }
        } else {
          $s2 = $this->peg_FAILED;
        }
        if ($s2 !== $this->peg_FAILED) {
          if (mb_substr($this->input, $this->peg_currPos, 3, "UTF-8") === $this->peg_c2) {
            $s3 = $this->peg_c2;
            $this->peg_currPos += 3;
          } else {
            $s3 = $this->peg_FAILED;
            if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c3); }
          }
          if ($s3 !== $this->peg_FAILED) {
            $s4 = $this->peg_parseWP_Block_Name();
            if ($s4 !== $this->peg_FAILED) {
              $s5 = array();
              $s6 = $this->peg_parseWS();
              if ($s6 !== $this->peg_FAILED) {
                while ($s6 !== $this->peg_FAILED) {
                  $s5[] = $s6;
                  $s6 = $this->peg_parseWS();
                }
              } else {
                $s5 = $this->peg_FAILED;
              }
              if ($s5 !== $this->peg_FAILED) {
                $s6 = $this->peg_currPos;
                $s7 = $this->peg_parseWP_Block_Attributes();
                if ($s7 !== $this->peg_FAILED) {
                  $s8 = array();
                  $s9 = $this->peg_parseWS();
                  if ($s9 !== $this->peg_FAILED) {
                    while ($s9 !== $this->peg_FAILED) {
                      $s8[] = $s9;
                      $s9 = $this->peg_parseWS();
                    }
                  } else {
                    $s8 = $this->peg_FAILED;
                  }
                  if ($s8 !== $this->peg_FAILED) {
                    $this->peg_reportedPos = $s6;
                    $s7 = $this->peg_f0($s4, $s7);
                    $s6 = $s7;
                  } else {
                    $this->peg_currPos = $s6;
                    $s6 = $this->peg_FAILED;
                  }
                } else {
                  $this->peg_currPos = $s6;
                  $s6 = $this->peg_FAILED;
                }
                if ($s6 === $this->peg_FAILED) {
                  $s6 = null;
                }
                if ($s6 !== $this->peg_FAILED) {
                  if (mb_substr($this->input, $this->peg_currPos, 3, "UTF-8") === $this->peg_c6) {
                    $s7 = $this->peg_c6;
                    $this->peg_currPos += 3;
                  } else {
                    $s7 = $this->peg_FAILED;
                    if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c7); }
                  }
                  if ($s7 !== $this->peg_FAILED) {
                    $this->peg_reportedPos = $s0;
                    $s1 = $this->peg_f7($s4, $s6);
                    $s0 = $s1;
                  } else {
                    $this->peg_currPos = $s0;
                    $s0 = $this->peg_FAILED;
                  }
                } else {
                  $this->peg_currPos = $s0;
                  $s0 = $this->peg_FAILED;
                }
              } else {
                $this->peg_currPos = $s0;
                $s0 = $this->peg_FAILED;
              }
            } else {
              $this->peg_currPos = $s0;
              $s0 = $this->peg_FAILED;
            }
          } else {
            $this->peg_currPos = $s0;
            $s0 = $this->peg_FAILED;
          }
        } else {
          $this->peg_currPos = $s0;
          $s0 = $this->peg_FAILED;
        }
      } else {
        $this->peg_currPos = $s0;
        $s0 = $this->peg_FAILED;
      }

      return $s0;
    }

    private function peg_parseWP_Block_End() {

      $s0 = $this->peg_currPos;
      if (mb_substr($this->input, $this->peg_currPos, 4, "UTF-8") === $this->peg_c0) {
        $s1 = $this->peg_c0;
        $this->peg_currPos += 4;
      } else {
        $s1 = $this->peg_FAILED;
        if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c1); }
      }
      if ($s1 !== $this->peg_FAILED) {
        $s2 = array();
        $s3 = $this->peg_parseWS();
        if ($s3 !== $this->peg_FAILED) {
          while ($s3 !== $this->peg_FAILED) {
            $s2[] = $s3;
            $s3 = $this->peg_parseWS();
          }
        } else {
          $s2 = $this->peg_FAILED;
        }
        if ($s2 !== $this->peg_FAILED) {
          if (mb_substr($this->input, $this->peg_currPos, 4, "UTF-8") === $this->peg_c8) {
            $s3 = $this->peg_c8;
            $this->peg_currPos += 4;
          } else {
            $s3 = $this->peg_FAILED;
            if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c9); }
          }
          if ($s3 !== $this->peg_FAILED) {
            $s4 = $this->peg_parseWP_Block_Name();
            if ($s4 !== $this->peg_FAILED) {
              $s5 = array();
              $s6 = $this->peg_parseWS();
              if ($s6 !== $this->peg_FAILED) {
                while ($s6 !== $this->peg_FAILED) {
                  $s5[] = $s6;
                  $s6 = $this->peg_parseWS();
                }
              } else {
                $s5 = $this->peg_FAILED;
              }
              if ($s5 !== $this->peg_FAILED) {
                if (mb_substr($this->input, $this->peg_currPos, 3, "UTF-8") === $this->peg_c6) {
                  $s6 = $this->peg_c6;
                  $this->peg_currPos += 3;
                } else {
                  $s6 = $this->peg_FAILED;
                  if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c7); }
                }
                if ($s6 !== $this->peg_FAILED) {
                  $this->peg_reportedPos = $s0;
                  $s1 = $this->peg_f8($s4);
                  $s0 = $s1;
                } else {
                  $this->peg_currPos = $s0;
                  $s0 = $this->peg_FAILED;
                }
              } else {
                $this->peg_currPos = $s0;
                $s0 = $this->peg_FAILED;
              }
            } else {
              $this->peg_currPos = $s0;
              $s0 = $this->peg_FAILED;
            }
          } else {
            $this->peg_currPos = $s0;
            $s0 = $this->peg_FAILED;
          }
        } else {
          $this->peg_currPos = $s0;
          $s0 = $this->peg_FAILED;
        }
      } else {
        $this->peg_currPos = $s0;
        $s0 = $this->peg_FAILED;
      }

      return $s0;
    }

    private function peg_parseWP_Block_Name() {

      $s0 = $this->peg_currPos;
      $s1 = $this->peg_currPos;
      $s2 = $this->peg_parseASCII_Letter();
      if ($s2 !== $this->peg_FAILED) {
        $s3 = array();
        $s4 = $this->peg_parseASCII_AlphaNumeric();
        if ($s4 === $this->peg_FAILED) {
          $s4 = $this->peg_currPos;
          if (mb_substr($this->input, $this->peg_currPos, 1, "UTF-8") === $this->peg_c10) {
            $s5 = $this->peg_c10;
            $this->peg_currPos++;
          } else {
            $s5 = $this->peg_FAILED;
            if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c11); }
          }
          if ($s5 !== $this->peg_FAILED) {
            $s6 = $this->peg_parseASCII_AlphaNumeric();
            if ($s6 !== $this->peg_FAILED) {
              $s5 = array($s5, $s6);
              $s4 = $s5;
            } else {
              $this->peg_currPos = $s4;
              $s4 = $this->peg_FAILED;
            }
          } else {
            $this->peg_currPos = $s4;
            $s4 = $this->peg_FAILED;
          }
        }
        while ($s4 !== $this->peg_FAILED) {
          $s3[] = $s4;
          $s4 = $this->peg_parseASCII_AlphaNumeric();
          if ($s4 === $this->peg_FAILED) {
            $s4 = $this->peg_currPos;
            if (mb_substr($this->input, $this->peg_currPos, 1, "UTF-8") === $this->peg_c10) {
              $s5 = $this->peg_c10;
              $this->peg_currPos++;
            } else {
              $s5 = $this->peg_FAILED;
              if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c11); }
            }
            if ($s5 !== $this->peg_FAILED) {
              $s6 = $this->peg_parseASCII_AlphaNumeric();
              if ($s6 !== $this->peg_FAILED) {
                $s5 = array($s5, $s6);
                $s4 = $s5;
              } else {
                $this->peg_currPos = $s4;
                $s4 = $this->peg_FAILED;
              }
            } else {
              $this->peg_currPos = $s4;
              $s4 = $this->peg_FAILED;
            }
          }
        }
        if ($s3 !== $this->peg_FAILED) {
          $s2 = array($s2, $s3);
          $s1 = $s2;
        } else {
          $this->peg_currPos = $s1;
          $s1 = $this->peg_FAILED;
        }
      } else {
        $this->peg_currPos = $s1;
        $s1 = $this->peg_FAILED;
      }
      if ($s1 !== $this->peg_FAILED) {
        $s0 = mb_substr($this->input, $s0, $this->peg_currPos - $s0, "UTF-8");
      } else {
        $s0 = $s1;
      }

      return $s0;
    }

    private function peg_parseWP_Block_Attributes() {

      $s0 = $this->peg_currPos;
      $s1 = $this->peg_currPos;
      $s2 = $this->peg_currPos;
      if (mb_substr($this->input, $this->peg_currPos, 1, "UTF-8") === $this->peg_c12) {
        $s3 = $this->peg_c12;
        $this->peg_currPos++;
      } else {
        $s3 = $this->peg_FAILED;
        if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c13); }
      }
      if ($s3 !== $this->peg_FAILED) {
        $s4 = array();
        $s5 = $this->peg_currPos;
        $s6 = $this->peg_currPos;
        $this->peg_silentFails++;
        $s7 = $this->peg_currPos;
        if (mb_substr($this->input, $this->peg_currPos, 1, "UTF-8") === $this->peg_c14) {
          $s8 = $this->peg_c14;
          $this->peg_currPos++;
        } else {
          $s8 = $this->peg_FAILED;
          if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c15); }
        }
        if ($s8 !== $this->peg_FAILED) {
          $s9 = array();
          $s10 = $this->peg_parseWS();
          if ($s10 !== $this->peg_FAILED) {
            while ($s10 !== $this->peg_FAILED) {
              $s9[] = $s10;
              $s10 = $this->peg_parseWS();
            }
          } else {
            $s9 = $this->peg_FAILED;
          }
          if ($s9 !== $this->peg_FAILED) {
            $s10 = $this->peg_c16;
            if ($s10 !== $this->peg_FAILED) {
              if (mb_substr($this->input, $this->peg_currPos, 1, "UTF-8") === $this->peg_c10) {
                $s11 = $this->peg_c10;
                $this->peg_currPos++;
              } else {
                $s11 = $this->peg_FAILED;
                if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c11); }
              }
              if ($s11 === $this->peg_FAILED) {
                $s11 = null;
              }
              if ($s11 !== $this->peg_FAILED) {
                if (mb_substr($this->input, $this->peg_currPos, 3, "UTF-8") === $this->peg_c6) {
                  $s12 = $this->peg_c6;
                  $this->peg_currPos += 3;
                } else {
                  $s12 = $this->peg_FAILED;
                  if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c7); }
                }
                if ($s12 !== $this->peg_FAILED) {
                  $s8 = array($s8, $s9, $s10, $s11, $s12);
                  $s7 = $s8;
                } else {
                  $this->peg_currPos = $s7;
                  $s7 = $this->peg_FAILED;
                }
              } else {
                $this->peg_currPos = $s7;
                $s7 = $this->peg_FAILED;
              }
            } else {
              $this->peg_currPos = $s7;
              $s7 = $this->peg_FAILED;
            }
          } else {
            $this->peg_currPos = $s7;
            $s7 = $this->peg_FAILED;
          }
        } else {
          $this->peg_currPos = $s7;
          $s7 = $this->peg_FAILED;
        }
        $this->peg_silentFails--;
        if ($s7 === $this->peg_FAILED) {
          $s6 = null;
        } else {
          $this->peg_currPos = $s6;
          $s6 = $this->peg_FAILED;
        }
        if ($s6 !== $this->peg_FAILED) {
          if (mb_strlen($this->input, "UTF-8") > $this->peg_currPos) {
            $s7 = mb_substr($this->input, $this->peg_currPos, 1, "UTF-8");
            $this->peg_currPos++;
          } else {
            $s7 = $this->peg_FAILED;
            if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c17); }
          }
          if ($s7 !== $this->peg_FAILED) {
            $s6 = array($s6, $s7);
            $s5 = $s6;
          } else {
            $this->peg_currPos = $s5;
            $s5 = $this->peg_FAILED;
          }
        } else {
          $this->peg_currPos = $s5;
          $s5 = $this->peg_FAILED;
        }
        while ($s5 !== $this->peg_FAILED) {
          $s4[] = $s5;
          $s5 = $this->peg_currPos;
          $s6 = $this->peg_currPos;
          $this->peg_silentFails++;
          $s7 = $this->peg_currPos;
          if (mb_substr($this->input, $this->peg_currPos, 1, "UTF-8") === $this->peg_c14) {
            $s8 = $this->peg_c14;
            $this->peg_currPos++;
          } else {
            $s8 = $this->peg_FAILED;
            if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c15); }
          }
          if ($s8 !== $this->peg_FAILED) {
            $s9 = array();
            $s10 = $this->peg_parseWS();
            if ($s10 !== $this->peg_FAILED) {
              while ($s10 !== $this->peg_FAILED) {
                $s9[] = $s10;
                $s10 = $this->peg_parseWS();
              }
            } else {
              $s9 = $this->peg_FAILED;
            }
            if ($s9 !== $this->peg_FAILED) {
              $s10 = $this->peg_c16;
              if ($s10 !== $this->peg_FAILED) {
                if (mb_substr($this->input, $this->peg_currPos, 1, "UTF-8") === $this->peg_c10) {
                  $s11 = $this->peg_c10;
                  $this->peg_currPos++;
                } else {
                  $s11 = $this->peg_FAILED;
                  if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c11); }
                }
                if ($s11 === $this->peg_FAILED) {
                  $s11 = null;
                }
                if ($s11 !== $this->peg_FAILED) {
                  if (mb_substr($this->input, $this->peg_currPos, 3, "UTF-8") === $this->peg_c6) {
                    $s12 = $this->peg_c6;
                    $this->peg_currPos += 3;
                  } else {
                    $s12 = $this->peg_FAILED;
                    if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c7); }
                  }
                  if ($s12 !== $this->peg_FAILED) {
                    $s8 = array($s8, $s9, $s10, $s11, $s12);
                    $s7 = $s8;
                  } else {
                    $this->peg_currPos = $s7;
                    $s7 = $this->peg_FAILED;
                  }
                } else {
                  $this->peg_currPos = $s7;
                  $s7 = $this->peg_FAILED;
                }
              } else {
                $this->peg_currPos = $s7;
                $s7 = $this->peg_FAILED;
              }
            } else {
              $this->peg_currPos = $s7;
              $s7 = $this->peg_FAILED;
            }
          } else {
            $this->peg_currPos = $s7;
            $s7 = $this->peg_FAILED;
          }
          $this->peg_silentFails--;
          if ($s7 === $this->peg_FAILED) {
            $s6 = null;
          } else {
            $this->peg_currPos = $s6;
            $s6 = $this->peg_FAILED;
          }
          if ($s6 !== $this->peg_FAILED) {
            if (mb_strlen($this->input, "UTF-8") > $this->peg_currPos) {
              $s7 = mb_substr($this->input, $this->peg_currPos, 1, "UTF-8");
              $this->peg_currPos++;
            } else {
              $s7 = $this->peg_FAILED;
              if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c17); }
            }
            if ($s7 !== $this->peg_FAILED) {
              $s6 = array($s6, $s7);
              $s5 = $s6;
            } else {
              $this->peg_currPos = $s5;
              $s5 = $this->peg_FAILED;
            }
          } else {
            $this->peg_currPos = $s5;
            $s5 = $this->peg_FAILED;
          }
        }
        if ($s4 !== $this->peg_FAILED) {
          if (mb_substr($this->input, $this->peg_currPos, 1, "UTF-8") === $this->peg_c14) {
            $s5 = $this->peg_c14;
            $this->peg_currPos++;
          } else {
            $s5 = $this->peg_FAILED;
            if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c15); }
          }
          if ($s5 !== $this->peg_FAILED) {
            $s3 = array($s3, $s4, $s5);
            $s2 = $s3;
          } else {
            $this->peg_currPos = $s2;
            $s2 = $this->peg_FAILED;
          }
        } else {
          $this->peg_currPos = $s2;
          $s2 = $this->peg_FAILED;
        }
      } else {
        $this->peg_currPos = $s2;
        $s2 = $this->peg_FAILED;
      }
      if ($s2 !== $this->peg_FAILED) {
        $s1 = mb_substr($this->input, $s1, $this->peg_currPos - $s1, "UTF-8");
      } else {
        $s1 = $s2;
      }
      if ($s1 !== $this->peg_FAILED) {
        $this->peg_reportedPos = $s0;
        $s1 = $this->peg_f9($s1);
      }
      $s0 = $s1;

      return $s0;
    }

    private function peg_parseASCII_AlphaNumeric() {

      $s0 = $this->peg_parseASCII_Letter();
      if ($s0 === $this->peg_FAILED) {
        $s0 = $this->peg_parseASCII_Digit();
        if ($s0 === $this->peg_FAILED) {
          $s0 = $this->peg_parseSpecial_Chars();
        }
      }

      return $s0;
    }

    private function peg_parseASCII_Letter() {

      if (Gutenberg_PEG_peg_regex_test($this->peg_c18, mb_substr($this->input, $this->peg_currPos, 1, "UTF-8"))) {
        $s0 = mb_substr($this->input, $this->peg_currPos, 1, "UTF-8");
        $this->peg_currPos++;
      } else {
        $s0 = $this->peg_FAILED;
        if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c19); }
      }

      return $s0;
    }

    private function peg_parseASCII_Digit() {

      if (Gutenberg_PEG_peg_regex_test($this->peg_c20, mb_substr($this->input, $this->peg_currPos, 1, "UTF-8"))) {
        $s0 = mb_substr($this->input, $this->peg_currPos, 1, "UTF-8");
        $this->peg_currPos++;
      } else {
        $s0 = $this->peg_FAILED;
        if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c21); }
      }

      return $s0;
    }

    private function peg_parseSpecial_Chars() {

      if (Gutenberg_PEG_peg_regex_test($this->peg_c22, mb_substr($this->input, $this->peg_currPos, 1, "UTF-8"))) {
        $s0 = mb_substr($this->input, $this->peg_currPos, 1, "UTF-8");
        $this->peg_currPos++;
      } else {
        $s0 = $this->peg_FAILED;
        if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c23); }
      }

      return $s0;
    }

    private function peg_parseWS() {

      if (Gutenberg_PEG_peg_regex_test($this->peg_c24, mb_substr($this->input, $this->peg_currPos, 1, "UTF-8"))) {
        $s0 = mb_substr($this->input, $this->peg_currPos, 1, "UTF-8");
        $this->peg_currPos++;
      } else {
        $s0 = $this->peg_FAILED;
        if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c25); }
      }

      return $s0;
    }

    private function peg_parseNewline() {

      if (Gutenberg_PEG_peg_regex_test($this->peg_c26, mb_substr($this->input, $this->peg_currPos, 1, "UTF-8"))) {
        $s0 = mb_substr($this->input, $this->peg_currPos, 1, "UTF-8");
        $this->peg_currPos++;
      } else {
        $s0 = $this->peg_FAILED;
        if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c27); }
      }

      return $s0;
    }

    private function peg_parse_() {

      if (Gutenberg_PEG_peg_regex_test($this->peg_c28, mb_substr($this->input, $this->peg_currPos, 1, "UTF-8"))) {
        $s0 = mb_substr($this->input, $this->peg_currPos, 1, "UTF-8");
        $this->peg_currPos++;
      } else {
        $s0 = $this->peg_FAILED;
        if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c29); }
      }

      return $s0;
    }

    private function peg_parse__() {

      $s0 = array();
      $s1 = $this->peg_parse_();
      if ($s1 !== $this->peg_FAILED) {
        while ($s1 !== $this->peg_FAILED) {
          $s0[] = $s1;
          $s1 = $this->peg_parse_();
        }
      } else {
        $s0 = $this->peg_FAILED;
      }

      return $s0;
    }

    private function peg_parseAny() {

      if (mb_strlen($this->input, "UTF-8") > $this->peg_currPos) {
        $s0 = mb_substr($this->input, $this->peg_currPos, 1, "UTF-8");
        $this->peg_currPos++;
      } else {
        $s0 = $this->peg_FAILED;
        if ($this->peg_silentFails === 0) { $this->peg_fail($this->peg_c17); }
      }

      return $s0;
    }

  public function parse($input) {
    $arguments = func_get_args();
    $options = count($arguments) > 1 ? $arguments[1] : array();
    $this->cleanup_state();
    $this->input = $input;
    $old_regex_encoding = mb_regex_encoding();
    mb_regex_encoding("UTF-8");

    $this->peg_FAILED = new stdClass;
    $this->peg_c0 = "<!--";
    $this->peg_c1 = array( "type" => "literal", "value" => "<!--", "description" => "\"<!--\"" );
    $this->peg_c2 = "wp:";
    $this->peg_c3 = array( "type" => "literal", "value" => "wp:", "description" => "\"wp:\"" );
    $this->peg_c4 = "/-->";
    $this->peg_c5 = array( "type" => "literal", "value" => "/-->", "description" => "\"/-->\"" );
    $this->peg_c6 = "-->";
    $this->peg_c7 = array( "type" => "literal", "value" => "-->", "description" => "\"-->\"" );
    $this->peg_c8 = "/wp:";
    $this->peg_c9 = array( "type" => "literal", "value" => "/wp:", "description" => "\"/wp:\"" );
    $this->peg_c10 = "/";
    $this->peg_c11 = array( "type" => "literal", "value" => "/", "description" => "\"/\"" );
    $this->peg_c12 = "{";
    $this->peg_c13 = array( "type" => "literal", "value" => "{", "description" => "\"{\"" );
    $this->peg_c14 = "}";
    $this->peg_c15 = array( "type" => "literal", "value" => "}", "description" => "\"}\"" );
    $this->peg_c16 = "";
    $this->peg_c17 = array("type" => "any", "description" => "any character" );
    $this->peg_c18 = "/^[a-zA-Z]/";
    $this->peg_c19 = array( "type" => "class", "value" => "[a-zA-Z]", "description" => "[a-zA-Z]" );
    $this->peg_c20 = "/^[0-9]/";
    $this->peg_c21 = array( "type" => "class", "value" => "[0-9]", "description" => "[0-9]" );
    $this->peg_c22 = "/^[-_]/";
    $this->peg_c23 = array( "type" => "class", "value" => "[-_]", "description" => "[-_]" );
    $this->peg_c24 = "/^[ \\t\\r\\n]/";
    $this->peg_c25 = array( "type" => "class", "value" => "[ \t\r\n]", "description" => "[ \t\r\n]" );
    $this->peg_c26 = "/^[\\r\\n]/";
    $this->peg_c27 = array( "type" => "class", "value" => "[\r\n]", "description" => "[\r\n]" );
    $this->peg_c28 = "/^[ \\t]/";
    $this->peg_c29 = array( "type" => "class", "value" => "[ \t]", "description" => "[ \t]" );

    $peg_startRuleFunctions = array( 'Document' => array($this, "peg_parseDocument") );
    $peg_startRuleFunction  = array($this, "peg_parseDocument");
    if (isset($options["startRule"])) {
      if (!(isset($peg_startRuleFunctions[$options["startRule"]]))) {
        throw new Exception("Can't start parsing from rule \"" + $options["startRule"] + "\".");
      }

      $peg_startRuleFunction = $peg_startRuleFunctions[$options["startRule"]];
    }

    /* BEGIN initializer code */

    // The `maybeJSON` function is not needed in PHP because its return semantics
    // are the same as `json_decode`

    /* END initializer code */

    $peg_result = call_user_func($peg_startRuleFunction);

    mb_regex_encoding($old_regex_encoding);
    if ($peg_result !== $this->peg_FAILED && $this->peg_currPos === mb_strlen($input, "UTF-8")) {
      return $peg_result;
    } else {
      if ($peg_result !== $this->peg_FAILED && $this->peg_currPos < mb_strlen($input, "UTF-8")) {
        $this->peg_fail(array("type" => "end", "description" => "end of input" ));
      }

      throw $this->peg_buildException(null, $this->peg_maxFailExpected, $this->peg_maxFailPos);
    }
  }

};